﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace OrgPlay {
    public partial class Form1 : Form {
        [DllImport("Org001.dll")]
        public static extern int StartOrganya(IntPtr hWnd);

        [DllImport("Org001.dll")]
        public static extern int LoadOrganya(string c);

        [DllImport("Org001.dll")]
        public static extern int PlayOrganyaMusic();

        [DllImport("Org001.dll")]
        public static extern int StopOrganyaMusic();

        [DllImport("Org001.dll")]
        public static extern int SetOrganyaPosition(int pos);

        [DllImport("Org001.dll")]
        public static extern int EndOrganya();

        Boolean loaded = false;
        Boolean playing = false;

        Bitmap backgroundImage = OrgPlay.Properties.Resources.picture00;

        public Form1() {
            InitializeComponent();
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e) {
            Console.WriteLine("--- rew");
            if(!loaded || !playing) return;
            SetOrganyaPosition(0);   
        }

        private void playToolStripMenuItem_Click(object sender, EventArgs e) {
            Console.WriteLine("--- play");
            if(!loaded || playing) return;
            PlayOrganyaMusic();
            playing = true;
        }

        private void pauseToolStripMenuItem_Click(object sender, EventArgs e) {
            Console.WriteLine("--- pause");
            if(!loaded || !playing) return;
            StopOrganyaMusic();
            playing = false;
        }

        private void Form1_Paint(object sender, PaintEventArgs e) {
            e.Graphics.DrawImage(backgroundImage, 0, 20);
        }

        private void Form1_DragEnter(object sender, DragEventArgs e) {
            if(e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effect = DragDropEffects.Copy;
        }

        private void Form1_DragDrop(object sender, DragEventArgs e) {
            Console.WriteLine("--- drop");
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            if(files.Length != 1 || !files[0].ToLowerInvariant().EndsWith(".org")) return;
            StopOrganyaMusic();
            playing = false;
            if(LoadOrganya(files[0]) == 0) return;
            loaded = true;
            int i = files[0].LastIndexOf('\\') + 1;
            string songName = files[0].Substring(i, files[0].Length - 4 - i);
            this.Text = "OrgPlay.net - " + songName;
        }

        private void Form1_Shown(object sender, EventArgs e) {
            Console.WriteLine("--- shown");
            StartOrganya(this.Handle);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e) {
            Console.WriteLine("--- closing");
            StopOrganyaMusic();
            playing = false;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e) {
            Console.WriteLine("--- closed");
            EndOrganya();
            loaded = false;
        }
    }
}
